/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.9 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 31.08.2010
Author  : GSD
Company : HOmeApp
Comments: 


Chip type               : ATtiny461
AVR Core Clock frequency: 1,000000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 64
*****************************************************/

#include <tiny461.h>
#include <delay.h>

#include <stdio.h>




#define PresADC         0
#define ZeroADC         1
#define TemperADC       0x3F
#define PressDelay      3
#define LowPresLimit    20               //      
#define HighPresLimit   35
#define Mem             PINA.7         
#define Dig10           PORTA.4         
#define Dig1            PORTA.5 
#define MemReset           PINA.6
int Offset;
unsigned char Counter;
unsigned char Scan;
unsigned char ButtonCode;
unsigned int PressEnableDelay;
unsigned char PressEnable;
unsigned char MemMode;        
int pressure,press_smooth;
int MinPress,MaxPress;
eeprom int MinPressE,MaxPressE;
unsigned char N1,N10;
bit Point;
unsigned char DigFlag;
unsigned char EnableConv;
unsigned char Disp1,Disp10;
flash unsigned char SymTable[]={0x40,0x79,0x24,0x30,0x19,0x12,0x03,0x78,0x00,0x18};
flash unsigned char TestTable[]={0x01,0x02,0x04,0x08,0x10,0x20,0x40};

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Place your code here
PressEnableDelay++;
if(PressEnableDelay >= PressDelay) {PressEnable=1;}
if(PressEnable == 1)
        {
        Scan = PINA;
        Scan=Scan & 0xC0;
        }
switch (DigFlag)
{
        case 0:
        {
        Dig10=0; //    
         Dig1= 1 && ~Point; //    
         PORTB=PORTB & 0x80;
         PORTB = PORTB |  Disp1;
//PORTB = Disp1;
        delay_us(50);
//         Strobe=0;
//         delay_us(100);
//         Strobe=1;
         
        DigFlag=1;
        }
        break;
        case 1:
        {
        Dig1=0;   //    
        Dig10= 1 && ~Point;  //    
        
         PORTB=PORTB & 0x80;
         PORTB = PORTB |  Disp10;
//PORTB = Disp10;
delay_us(50);
//         Strobe=0;
//         delay_us(100);
//         Strobe=1;
         
         
        DigFlag=0;
        EnableConv=1;
        }
        break;

}

// Reinitialize Timer 0 value
//TCNT0H=0xD9 >> 8;
TCNT0L=0xD9;
// Place your code here

}





#define ADC_VREF_TYPE 0x1E0

// Read the 8 most significant bits
// of the AD conversion result
unsigned char read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCH;
}


// System initialization
void SysInit(void)
{


// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=Out Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0xC0;
DDRA=0x34;

// Port B initialization
// Func7=In Func6=Out Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=T State6=0 State5=T State4=T State3=0 State2=0 State1=0 State0=0 
PORTB=0x00;
DDRB=0x7F;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 3,906 kHz
// Mode: 8bit top=FFh
TCCR0A=0x00;
TCCR0B=0x04;
TCNT0H=0x00;
TCNT0L=0xD9;
OCR0A=0x00;
OCR0B=0x00;




// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-7, 12-15: Off
// Interrupt on any change on pins PCINT8-11: Off
MCUCR=0x00;
GIMSK=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x02;
// Universal Serial Interface initialization
// Mode: Three Wire (SPI)
// Clock source: Reg.=ext. pos., Cnt.=ext. both edges
// USI Counter Overflow Interrupt: Off
//USICR=0x18;

// Analog Comparator initialization
// Analog Comparator: Off
ACSRA=0x80;
// Hysterezis level: 0 mV
ACSRB=0x00;

// ADC initialization
// ADC Clock frequency: 31,250 kHz
// ADC Voltage Reference: 2.56V, cap. on AREF
// ADC Bipolar Input Mode: Off
// ADC Auto Trigger Source: None
// Digital input buffers on ADC0: Off, ADC1: On, ADC2: On, Aref: Off
// ADC3: On, ADC4: On, ADC5: On, ADC6: On
DIDR0=0x0B;
// Digital input buffers on ADC7: On, ADC8: On, ADC9: On, ADC10: On
DIDR1=0x00;
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x85;
ADCSRB&=0x7F;
ADCSRB|=0x00 | ((ADC_VREF_TYPE & 0x100) >> 4);


// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/512k
// Watchdog Timer interrupt: Off
#pragma optsize-
#asm("wdr")
WDTCR=0x38;
WDTCR=0x28;


// Global enable interrupts
#asm("sei")

}

unsigned char GetScanCode(void)
{
if((Scan != 0xC0)||(Scan >= 0x40)) 
        {
        PressEnableDelay=0;
        PressEnable=0;
        return(Scan);
        }
else return(0);
}

void BinToBcd(unsigned char Mod)
{
if(EnableConv == 1)
{

switch(Mod)
{
 case 'M':
        {
        switch (MemMode)
        {
        case 0:
        {
        N10 = (unsigned char)(MaxPress/10);
        N1 = (unsigned char)(MaxPress -(int)N10*10);
        }
        break;
        case 1:
        {
        N10 = (unsigned char)(MinPress/10);
        N1 = (unsigned char)(MinPress -(int)N10*10);
        
        }
        break;
        }
        }
 break;
 case 'R':
        {
        N10 = (unsigned char)(press_smooth/10);
        N1 = (unsigned char)(press_smooth-(int)N10*10);
        }
 break;
}

//N10 = (unsigned char)(press_smooth/10);
//N1 = (unsigned char)(press_smooth-(int)N10*10);
//if(pressure < 0) {N1=0;N10=0;}
Disp1=~SymTable[N1];
Disp10 = ~SymTable[N10];
EnableConv=0;
EnableConv=0;
}

}

void MinMax(void)
{
if(press_smooth < MinPress) {MinPress = press_smooth; MinPressE=MinPress;}
if(press_smooth > MaxPress) {MaxPress = press_smooth; MaxPressE=MaxPress;}
}

void SelfCheck(void)
{
unsigned char Ticker,Repeat;;
for(Repeat=0;Repeat< 9;Repeat++)
{
#asm("wdr")
for(Ticker=0;Ticker<7;Ticker++)
{
Disp1=Disp10=TestTable[Ticker];
delay_ms(100);
}

}
Offset=(int)(read_adc(ZeroADC));
pressure = (int)(read_adc(PresADC))-40-Offset;
if(pressure < 0) pressure=0;
pressure >>=2;
press_smooth=pressure;
MinPress=MaxPress=press_smooth;
}

// Declare your global variables here

void main(void)
{
// Declare your local variables here
unsigned char Mode;

// Reset Source checking
if (MCUSR & 1)
   {
   // Power-on Reset
   MCUSR=0;
   // Place your code here
   SysInit();
//Segment=0;
DigFlag=0;
//Strobe=1;
Dig1=Dig10=0;
Point=0;
Mode='R';
MemMode=0;
Counter=0;
//Mask=0xFE;

SelfCheck();
   }
else if (MCUSR & 2)
   {
   // External Reset
   MCUSR=0;
   // Place your code here
 SysInit();
//Segment=0;
DigFlag=0;
//Strobe=1;
Dig1=Dig10=0;
Point=0;
Mode='R';
MemMode=0;
Counter=0;
//Mask=0xFE;

SelfCheck();
   }
else if (MCUSR & 4)
   {
   // Brown-Out Reset
   MCUSR=0;
   // Place your code here

   }
else
   {
   // Watchdog Reset
   MCUSR=0;
   // Place your code here
 SysInit();
//Segment=0;
DigFlag=0;
//Strobe=1;
Dig1=Dig10=0;
Point=0;
Mode='R';
MemMode=0;
Counter=0;
//Mask=0xFE;


   };




while (1)
      {
      // Place your code here
       
         ButtonCode=GetScanCode();
         #asm("wdr")
      switch(ButtonCode)
      {
       case 0x80:                       //  
                {
                MaxPress = MinPress = press_smooth;
                MaxPressE=MinPressE=MinPress;
                }
       break;
       case 0x40:                       //  
                {
                if (Mode == 'M') Mode = 'R';
                else Mode='M';
                }
       break;
      
        }

        pressure = (int)(read_adc(PresADC))-40-Offset;
        
        if(pressure < 0) pressure=0;
        pressure >>=2;
        press_smooth=press_smooth+pressure;
        press_smooth=press_smooth >> 1;
        MinMax();
       BinToBcd(Mode);
        //      
        if((press_smooth < LowPresLimit) || (press_smooth > HighPresLimit))  Point=~Point;
        else
        {                                                      
         Point=0;  //..  
        }
       Counter++;
       if(Counter == 2)
       {
       if(MemMode == 0) MemMode=1;
       else MemMode=0;
       Counter=0;
       }
 //    POINT=Point;
      delay_ms(500);
       

  
      };
}
